/**
 * @file Phase10Card.h
 *
 * @brief Classes to represent Phase 10 cards
 *
 * @ingroup CommonTypes
 *
 * @author Devon Johnson
 *
 */

#pragma once

// Includes
#include <string>

#include <Phase10/CommonTypes.h>
#include <System/Serializable.h>

namespace Phase10
{
  /////////////////////////////////////////////////////////////////////////////
  /// @brief Converts the color to string
  /// @param color - color to convert
  /// @return - string representation of color
  /////////////////////////////////////////////////////////////////////////////
  const std::string& ColorToString(CardColor color);

  //-------------------------------------------------------------------------//
  // Class:       Card
  // Description: Phase 10 cards
  //-------------------------------------------------------------------------//
  class Card : public System::Serializable
  {
  public:
    ///////////////////////////////////////////////////////////////////////////
    /// @brief Constructor
    /// @param value - card value
    /// @param color - card color
    ///////////////////////////////////////////////////////////////////////////
    Card(CardValue value = VALUE_INVALID, CardColor color = COLOR_NONE);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Destructor
    ///////////////////////////////////////////////////////////////////////////
    virtual ~Card() = default;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Equality operator
    /// @param other - another instance
    /// @return - true if equal, else false
    ///////////////////////////////////////////////////////////////////////////
    bool operator==(const Card& other) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Inequality operator
    /// @param other - another instance
    /// @return - true if not equal, else false
    ///////////////////////////////////////////////////////////////////////////
    bool operator!=(const Card& other) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Greater than operator
    /// @param other - another instance
    /// @return - true if this < other, else false
    ///////////////////////////////////////////////////////////////////////////
    bool operator>(const Card& other) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Greater than or equal to operator
    /// @param other - another instance
    /// @return - true if this < other, else false
    ///////////////////////////////////////////////////////////////////////////
    bool operator>=(const Card& other) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Less than operator
    /// @param other - another instance
    /// @return - true if this < other, else false
    ///////////////////////////////////////////////////////////////////////////
    bool operator<(const Card& other) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Less than or equal to operator
    /// @param other - another instance
    /// @return - true if this < other, else false
    ///////////////////////////////////////////////////////////////////////////
    bool operator<=(const Card& other) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Decodes the member data from the buffer
    /// @param buffer - buffer to append to
    /// @return - true if successful, else false
    ///////////////////////////////////////////////////////////////////////////
    virtual bool decode(System::SerialBuffer& buffer);

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Encodes the member data into the buffer
    /// @param buffer - buffer to append to
    /// @return - None
    ///////////////////////////////////////////////////////////////////////////
    virtual void encode(System::SerialBuffer& buffer) const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the card color
    /// @return - card color
    ///////////////////////////////////////////////////////////////////////////
    CardColor getColor() const { return mColor; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the point value for this card
    /// @return - points for this card
    ///////////////////////////////////////////////////////////////////////////
    size_t getPoints() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets the card value
    /// @return - card value
    ///////////////////////////////////////////////////////////////////////////
    CardValue getValue() const { return mValue; }

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if card is a skip card
    /// @return - true if skip card, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isSkip() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if card is a standard card
    /// @return - true if standard card, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isStandard() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if card is valid
    /// @return - true if valid, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isValid() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Determines if card is a wild card
    /// @return - true if wild card, else false
    ///////////////////////////////////////////////////////////////////////////
    bool isWild() const;

    ///////////////////////////////////////////////////////////////////////////
    /// @brief Gets a string representation of the card
    /// @return - string
    ///////////////////////////////////////////////////////////////////////////
    std::string toString() const;

  private:
    // Private class variables
    CardColor mColor; ///< card color
    CardValue mValue; ///< card value
  };

} // namespace Phase 10
